<?php
namespace HCM\BTL\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class UploadsRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function insertGpeAnexos($nranexo, $nrorg, $nrparcnegocio, $nmanexo, $dsreferencia, $type, $cdoperador, $path, $idfoto) {
        $dtatual = date("d/m/Y");
        $query = $this->entityManager->getConnection()->prepare("
            INSERT INTO GPE_ANEXOS 
                    (NRANEXO,
                    NRORG,
                    NRPARCNEGOCIO,
                    NMANEXO,
                    DSREFERENCIA,
                    IDTYPE,
                    DSPATH,
                    DTINCLUSAO,
                    DTULTATU,
                    CDOPERINCLUSAO,
                    CDOPERULTATU,
                    IDFOTO)
            VALUES (:NRANEXO,
                    :NRORG, 
                    :NRPARCNEGOCIO,
                    TO_CHAR('$nmanexo'),
                    :DSREFERENCIA,
                    :IDTYPE,
                    :DSPATH,
                    :DTATUAL,
                    :DTATUAL,
                    :CDOPERADOR,
                    :CDOPERADOR,
                    :IDFOTO)
        ");
       
        //$this->connection->execute();

        $query->execute(
            array(
              "NRORG"         => $nrorg,
              "NRPARCNEGOCIO" => $nrparcnegocio,
              //"NMANEXO"     => $nmanexo,
              "NRANEXO"       => $nranexo,
              "DSREFERENCIA"  => $dsreferencia,
              "IDTYPE"        => $type,
              "DTATUAL"       => $dtatual,
              "CDOPERADOR"    => $cdoperador,
              "DSPATH"        => $path,
              "IDFOTO"        => $idfoto
            )
        );
    }
    
    public function getGpeAnexo($nranexo, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
            SELECT NRANEXO, NRORG, NRPARCNEGOCIO, NMANEXO, DSREFERENCIA, DSPATH, IDFOTO FROM GPE_ANEXOS WHERE NRORG = :P_NRORG AND NRANEXO = :P_NRANEXO
        ");

        $query->execute(array(          
              "P_NRANEXO" => $nranexo,
              "P_NRORG"   => $nrorg,
            )
        );

        return $query->fetchAll();
    }
    
    public function updateGpeAnexos($nranexo, $nrorg, $nrparcnegocio, $nmanexo, $dsreferencia, $type, $cdoperador, $path, $idfoto) {
        $dtatual = date("d/m/Y");
        $query = $this->entityManager->getConnection()->prepare("
            UPDATE GPE_ANEXOS
               SET NMANEXO = TO_CHAR('$nmanexo'),
                   DSREFERENCIA = :DSREFERENCIA, 
                   IDTYPE = :IDTYPE, 
                   DSPATH = :DSPATH, 
                   DSURL = :DSURL, 
                   DTULTATU = :DTATUAL, 
                   CDOPERULTATU = :CDOPERADOR
            WHERE NRANEXO = :NRANEXO 
              AND NRPARCNEGOCIO = :NRPARCNEGOCIO 
              AND IDFOTO = :IDFOTO
              AND NRORG = :NRORG
        ");
       
        //$this->connection->execute();

        $query->execute(
            array(
              "NRORG"         => $nrorg,
              "NRPARCNEGOCIO" => $nrparcnegocio,
              "NRANEXO"       => $nranexo,
              "DSREFERENCIA"  => $dsreferencia,
              "IDTYPE"        => $type,
              "DSURL"         => null,
              "DTATUAL"       => $dtatual,
              "CDOPERADOR"    => $cdoperador,
              "DSPATH"        => $path,
              "IDFOTO"        => $idfoto
            )
        );
    }
}