<?php

namespace HCM\FPA\Calculos\Apolo;

require_once __DIR__.'/bootstrapConsumer.php';
error_reporting(E_ERROR | E_PARSE);
ini_set("memory_limit","2048M");

use Teknisa\Model\Gestaopessoas\Repositories\FpaCalculoconsumer;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\Util\Mail\Mail;
use HCM\FPA\Calculos\Apolo\PercorreCalculoConsumer;
use Zeedhi\Framework\Session\Session;
use Teknisa\Libs\Util\SMTP;

class ExportacaoConsumer extends \Zeedhi\Queue\Consumer {

    const QUEUE_NAME_EXPORTACAO = "hcm_exportacaoFichaFinanceira_";

	protected static $queueName = '/queue/';
    public $fpaCalculoConsumer;
    private $nrcalculoconsumer;
    private $dsemailoper;
    private $cdoperador;
    private $dtmescompetencia;
    private $nrorg;
    private $tp_processamento;
    private $tipo_calculo;
    private $nrFormulario;
    private $pid;
    private $corpoEmail;
    
    public function __construct($hcmParameters, $migracaoFichaFinanceiraService, $entityManager, $connection, $queueName){
        parent::__construct($connection);
        self::$queueName = $queueName;
        $this->pid = getmypid();
        $this->entityManager = $entityManager;
        $this->migracaoFichaFinanceiraService = $migracaoFichaFinanceiraService;
        $this->jenkins = true;
        $this->hcmParameters = $hcmParameters;
        $this->msg = array();
        $this->fpa_loteLancEven = Repositories::FPA_LOTELANCEVENTO;
        $this->fpa_itemlotelanc = Repositories::FPA_ITEMLOTELANC;
        // Para testar comente essa linha
        $this->runAndFinish();
    }
    
	/**
     * @param string $message
     * @return void
     */
    public function consume($message) {        
        // Tempo de execucao deve ser ilimitado.
        // Tempo de execucao deve ser ilimitado.
        set_time_limit(0);
        error_reporting(E_ERROR | E_PARSE);
    	try {
            echo ">>>>>>>>>> Iniciando Processo <<<<<<<<<<".PHP_EOL;
            echo 'Pid = '.$this->pid.PHP_EOL;
            
            $consumerParams = json_decode($message, true)[0];
            $exportacaoItensParams  = empty($consumerParams['EXPORTACAO_PARAMS'][0]) ? $consumerParams['EXPORTACAO_PARAMS'] : $consumerParams['EXPORTACAO_PARAMS'][0];
            
            $this->setParameters($exportacaoItensParams);
            
            $this->entityManager->beginTransaction();
            
            $this->calculoFolha   = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->findOneBy(array('nrorg' => $this->nrorg, 'nrcalculofolha' => $this->nrCalculoFolha));
            $this->loteLancEvento = $this->entityManager->getRepository(Repositories::FPA_LOTELANCEVENTO)->findOneBy(array('nrorg' => $this->nrorg, 'nrlotelancevento' => $this->nrLoteLancEvento));
            
            $nritens = '';
            $countItens = 0;
            
            
            foreach($this->dataSet as $nritlotelanc){
                $iteLoteLanc = $this->entityManager->getRepository(Repositories::FPA_ITEMLOTELANC)->findOneBy(array('nrorg' => $this->nrorg, 'nritlotelanc' => $nritlotelanc, 'nrlotelancevento' => $this->nrLoteLancEvento));
                $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento($iteLoteLanc->getNreventom(), $this->nrorg, $this->hcmParameters->getNrOrgPadrao(), $this->dtmescompetencia);
                
                $novoItem = $this->novoItemCalcFolha($this->nrorg, $iteLoteLanc->getNrvinculom(), $iteLoteLanc->getNreventom(), $this->nrCalculoFolha, $this->nrLoteLancEvento, DateUtil::getDataDeString($iteLoteLanc->getDtocorrencia(), DateUtil::FORMATO_BRASILEIRO,
                                                     true), $evento->historico->getIdeventodemonst(), $iteLoteLanc->getVreventolote(), $iteLoteLanc->getVrreffolhalote(), 'REFERENCIA_VALOR', $iteLoteLanc->getDsobservacao());
                $nritens .= $novoItem->getNritemcalcfolha().","; 
                $countItens++;
            }
            
            // Define parametros do operador.
            $this->showAmbiente();
             
            $this->loteLancEvento->setIdstatuslotelanc('APROVADO');
            $this->entityManager->persist($this->loteLancEvento);
            $this->entityManager->flush();
            
            
            $this->entityManager->commit();
            //Envia email para o operador informando o término do calculo.
            $this->notificaExportacao($resultado, $nritens);
            $pid = explode(',', $calculoConsumer[0]['DSPIDPROCESSO']);
            return array(true, $this->pid, array_unique($pid));
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            echo "Erro: ".$e->getMessage();
            $this->kill($this->pid);
            die();
        }
    }
    
    public function novoItemCalcFolha($nrorg, $nrvinculom, $nreventom, $nrcalculofolha, $nrlotelancevento, $dtocorrencia, $idevendemoncalc, $vreventofolha, $vrreffolha, $idrefevalorcalc, $dsitemcalcfolha = null, $dtgerultcnab = null, $qtocorproxperi = null, 
                                      $vrvelho = null, $nrgozoferias = null){
        $fpa_itecalcfolha = Repositories::FPA_ITECALCFOLHA;
        $item = new $fpa_itecalcfolha;
        
        $item->setNrorg($nrorg);
        $item->setNrvinculom($nrvinculom);
        $item->setNreventom($nreventom);
        $item->setNrcalculofolha($nrcalculofolha);
        $item->setNrlotelancevento($nrlotelancevento);
        $item->setDtocorrencia($dtocorrencia);
        $item->setIdevendemoncalc($idevendemoncalc);
        $item->setVreventofolha($vreventofolha);
        $item->setVrreffolha($vrreffolha);
        $item->setDsitemcalcfolha($dsitemcalcfolha);
        $item->setDtgerultcnab($dtgerultcnab);
        $item->setIdrefevalorcalc($idrefevalorcalc);
        $item->setQtocorproxperi($qtocorproxperi);
        $item->setVrvelho($vrvelho);
        $item->setNrgozoferias($nrgozoferias);
        
        
        $item->setDtinclusao(DateUtil::getDataAtual());
        $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $item->setDtultatu(DateUtil::getDataAtual());
        $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $item->setCdoperultatu($this->hcmParameters->getCdoperador());
        
        $item->setNritemcalcfolha(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ITECALCFOLHA', 1, 12, true));
        
        $this->entityManager->persist($item);
        $this->entityManager->flush();
        return $item; 
    }
    
    public function notificaExportacao($resultado, $item){
        $cdoperador = FPA::getCdOperador();
        $operador = self::retornaOperadorLogado($cdoperador);

        $emailOperadorLogado = $operador->getDsemailoper();
        $nomeOperadorLogado = $operador->getNmoperador();
        
        $corpo_msg = $nomeOperadorLogado.','."<br>"."<br> Importação do(s) item(ns) ".$item."Finalizado "."<br>"."<br>";

        $nome_destinatario  = $nomeOperadorLogado;
        
        $mail = $this->hcmParameters->returnParamsSmtp(true);
 
        if(!$mail){
            return;
        }
        
        try {
            
            $mail->newEmail($emailOperadorLogado,  //De/From
                $corpo_msg,                     //texto
                $assunto,                       // assunto    
                $nomeOperadorLogado,            //nome operador
                $nomeOperadorLogado,            //nome from
                $emailOperadorLogado           //from
                );
        }catch (Exception $e) {
            $contFail++;
        }
    }

    public function retornaOperadorLogado($cdoperador){
        $operador = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $cdoperador));
        return $operador;
    }

    private function setParameters($exportacaoItensParams) {
        
        $this->dataSet           = $exportacaoItensParams["DATASET"];
        $this->dsemailoper       = $exportacaoItensParams["DSEMAILOPER"];
        $this->cdoperador        = $exportacaoItensParams["CDOPERADOR"];
        $this->dtmescompetencia  = $exportacaoItensParams["DTMESCOMPETENCIA"];
        $this->nrorg             = $exportacaoItensParams["NRORG"];
        $this->nrCalculoFolha    = $exportacaoItensParams['NRCALCULOFOLHA'];
        $this->nrLoteLancEvento  = $exportacaoItensParams['NRLOTELANCEVENTO'];
        
        foreach ($exportacaoItensParams["PARAMSHCM"] as $key => $value) {
            $this->hcmParameters->set($key, $value);
        }
    }

    private function showAmbiente() {
        $dataExecucao       = DateUtil::getDataAtual();

        $ambiente .= "Org.: $this->nrorg\nCompetencia: $this->dtmescompetencia\nExportação Ficha Financeira: $this->nrlotelancevento\n
                      Operador: $this->cdoperador\nData Execucao: $dataExecucao";
        
        
        echo "<br>"."---------------"."<br>";

        // set a propriedade DSOBSLOTELANC do registro em lotelacevento
        $this->loteLancEvento->setDsobslotelanc(str_replace("\n", " - ", $ambiente));
    }
}
