<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use HCM\FPA\Repository\ParametroFolhaRepository;

class ParametroFolhaService {
    
    protected $entityManager;
    protected $hcmParameters;
    protected $parametroFolhaRepository;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters,ParametroFolhaRepository $parametroFolhaRepository ) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->parametroFolhaRepository = $parametroFolhaRepository;
    }
    
    public function validaSalvar($nrgrpincide){
          $valor=$this->parametroFolhaRepository->ParametroFolhaRepository($nrgrpincide);
          foreach($valor as & $row){
          if($row["COUNT(*)"]>0.0){
         return false;   
        }
        return true;
    }
    }
    
    
    public function deleteParametroFolha($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $parametroFolhah = $this->entityManager->getRepository(Repositories::FPA_PARAMFOLHAH)->findOneBy(array("nrparamfolham" => $dataset['NRPARAMFOLHAM'], "nrparamfolhah" => $dataset['NRPARAMFOLHAH']));
            $this->entityManager->remove($parametroFolhah);
            $this->entityManager->flush($parametroFolhah);
            $parametroFolhahh = $this->entityManager->getRepository(Repositories::FPA_PARAMFOLHAH)->findOneBy(array("nrparamfolham" => $dataset['NRPARAMFOLHAM']));
            if(empty($parametroFolhahh)) {
                $parametroFolham = $this->entityManager->getRepository(Repositories::FPA_PARAMFOLHAM)->findOneBy(array("nrparamfolham" => $dataset['NRPARAMFOLHAM'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($parametroFolham);
                $this->entityManager->flush($parametroFolham);
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
}