<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 17/02/2016
 * Time: 10:51
 */

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use Geral\Entities\Itemprojimport;
use Geral\Entities\Logprojimport;
use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;
use HCM\Util\HCMParameters;
use Zeedhi\Framework\HTTP\Kernel;
use HCM\BTL\Repository\UploadsRepository;
use Zeedhi\Framework\Remote\FileUploader\Server;

class UploadFileService {

    protected $entityManager;
    /** @var Environment */
    protected $hcmParameters;
    private $httpKernel;
    private $connection;
    protected $uploadsRepository;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, Kernel $httpKernel, UploadsRepository $uploadsRepository, Server $zhFileUploader) {
        $this->entityManager     = $entityManager;
        $this->hcmParameters     = $hcmParameters;
        $this->httpKernel        = $httpKernel;
        $this->uploadsRepository = $uploadsRepository;
        $this->connection        = $this->entityManager->getConnection();
        $this->zhFileUploader    = $zhFileUploader;
    }
    
    public function setGpeAnexos($dataset) {
        if (array_key_exists('DSPATH', $dataset)) {
            if (is_array($dataset['DSPATH'])) {
                $arquivos = $dataset['DSPATH'];
                foreach ($arquivos as $fileData) {
                    $type = null;
                    if(is_null($fileData["type"]) || $fileData["type"] == ''){
                        $type = explode('.', $fileData["name"])[1];
                    } else {
                        $type = $fileData["type"];
                    }

                    $path = $fileData["path"];
                    if (!isset($dataset['DSREFERENCIA']))
                        $dataset['DSREFERENCIA'] = $fileData['name'];

                    if (array_key_exists('NRANEXO', $dataset) && $dataset['NRANEXO'] != '' && $dataset['NRANEXO'] != null) {
                        $file = $this->getGpeAnexo($dataset['NRANEXO'], $dataset['NRORG']);
                        if ($file) {
                            $this->uploadsRepository->updateGpeAnexos($dataset['NRANEXO'], $dataset['NRORG'], $dataset['NRPARCNEGOCIO'], $fileData["name"], $dataset['DSREFERENCIA'], $type, $dataset['CDOPERADOR_LOG'], $path, $dataset['IDFOTO']);
                        }
                    } else {
                        $nranexo = \HCM\Util\NovoCodigo::geraCodigo($dataset['NRORG'], 'GPE_ANEXOS', 1, 12, true);
                        $this->uploadsRepository->insertGpeAnexos($nranexo, $dataset['NRORG'], $dataset['NRPARCNEGOCIO'], $fileData["name"], $dataset['DSREFERENCIA'], $type, $dataset['CDOPERADOR_LOG'], $path, $dataset['IDFOTO']);                    
                    }
                    
                    // $this->entityManager->flush();
                }
            }
            return true;

        } else {
            return false;
        }
    }
    
    public function deleteUploadFile($filePath) {
        try{
            $this->zhFileUploader->deleteFile($filePath);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getGpeAnexo($nranexo, $nrorg) {
        $file = $this->uploadsRepository->getGpeAnexo($nranexo, $nrorg);
        if (count($file) > 0)
            return $file;
        else 
            return false;
    }

}