/*
-- ========================================================================== --
-- SISTEMA         : COMISSARIA                                               --
-- DATA DA CRIAO : INCIO - 29/07/98                                        --
-- PROGRAMADOR     : ANDERSON                                                 --
-- OBJETIVOS       : RETORNA A SOMATORIA DAS QTDES DE PAX E STANDBY           --
-- MANUTENCOES     : Marcelo - Alterao para funcionar com Filial            --
-- ========================================================================== --
-- @C:\WIN_V1.53\SQL\ORACLE\2500_ATESTP_SOMAQTEPAXSBY.SQL
-- @C:\WIN_PRJ\SQL\ORACLE\2500_ATESTP_SOMAQTEPAXSBY.SQL
-- ========================================================================== --
*/
CREATE OR REPLACE PROCEDURE SOMATORIA_QTDE_PAX_STANDBY(
  P_CDFILIAL            IN FILIAL.CDFILIAL%TYPE,
  P_CDCIA               IN COMPANHIA.CDCIA%TYPE,
  P_NRVOO               IN VOO.NRVOO%TYPE,
  P_CDTRECHO            IN VOOTRECHO.CDTRECHO%TYPE,
  P_CDCLASSE            IN CLASSE.CDCLASSE%TYPE,
  P_QTTOTPAXAT_QTPAXSBY IN OUT PREVISAOPAX.QTTOTPAXAT%TYPE,
  P_QTTOTPAXAT          IN OUT PREVISAOPAX.QTTOTPAXAT%TYPE,
  P_QTPAXSBY            IN OUT PREVISAOPAX.QTTOTPAXAT%TYPE,
  P_CDEQUIP             IN VOO.CDEQUIP  %TYPE DEFAULT NULL,
  P_SGPREFIXO           IN VOO.SGPREFIXO%TYPE DEFAULT NULL
)AS
  V_CDEQUIP                VOO.CDEQUIP  %TYPE;
  V_SGPREFIXO              VOO.SGPREFIXO%TYPE;
BEGIN
-- ========================================================================== --
--            GARANTIR QUE TODAS AS QUANTIDADES NO ESTEJAM NULAS             --
-- ========================================================================== --
   UPDATE CONFIGVOO
   SET QTPAXSBYVOO = 0
   WHERE (QTPAXSBYVOO IS NULL);

   UPDATE CONFIGPREF
   SET QTPAXSBYPREF = 0
   WHERE (QTPAXSBYPREF IS NULL);

   UPDATE CONFIGEQUI
   SET QTPAXSBYEQUI = 0
   WHERE (QTPAXSBYEQUI IS NULL);
-- ========================================================================== --
--         BUSCAR A SOMATORIA DAS QTDES DE PAX E STANDBY NAS                  --
--         CONFIGS(VOO, PREFIXO, EQUIPAMENTO, CLASSECIA)                      --
-- ========================================================================== --
   SELECT MAX(QTPAXVOO), MAX(QTPAXSBYVOO)
   INTO P_QTTOTPAXAT, P_QTPAXSBY
   FROM CONFIGVOO
   WHERE (CDFILIAL = P_CDFILIAL) AND
         (CDCIA    = P_CDCIA   ) AND
         (NRVOO    = P_NRVOO   ) AND
         (CDTRECHO = P_CDTRECHO) AND
         (CDCLASSE = P_CDCLASSE);

   IF (P_QTTOTPAXAT + P_QTPAXSBY) IS NULL THEN
   BEGIN
      IF P_CDEQUIP IS NULL THEN
         SELECT CDEQUIP, SGPREFIXO
         INTO V_CDEQUIP, V_SGPREFIXO
         FROM VOO
         WHERE (CDFILIAL = P_CDFILIAL) AND
               (CDCIA    = P_CDCIA   ) AND
               (NRVOO    = P_NRVOO   );
      ELSE
         V_CDEQUIP   := P_CDEQUIP;
         V_SGPREFIXO := P_SGPREFIXO;
      END IF;

      SELECT MAX(QTPAXPREFIXO),MAX(QTPAXSBYPREF)
      INTO P_QTTOTPAXAT, P_QTPAXSBY
      FROM CONFIGPREF
      WHERE (CDFILIAL  = P_CDFILIAL ) AND
            (CDCIA     = P_CDCIA    ) AND
            (CDCLASSE  = P_CDCLASSE ) AND
            (SGPREFIXO = V_SGPREFIXO);
      IF (P_QTTOTPAXAT + P_QTPAXSBY) IS NULL THEN
         SELECT MAX(QTPAXEQUI),MAX(QTPAXSBYEQUI)
         INTO P_QTTOTPAXAT, P_QTPAXSBY
         FROM CONFIGEQUI
         WHERE (CDFILIAL = P_CDFILIAL) AND
               (CDCIA    = P_CDCIA   ) AND
               (CDCLASSE = P_CDCLASSE) AND
               (CDEQUIP  = V_CDEQUIP );
      END IF;
      /*SELECT MAX(QTPAXPREFIXO),MAX(QTPAXSBYPREF)
      INTO P_QTTOTPAXAT, P_QTPAXSBY
      FROM CONFIGPREF CP, VOO VO
      WHERE (CP.CDFILIAL  = P_CDFILIAL  ) AND
            (CP.CDCIA     = P_CDCIA     ) AND
            (CP.CDCLASSE  = P_CDCLASSE  ) AND
            (CP.SGPREFIXO = VO.SGPREFIXO) AND
            (VO.CDFILIAL  = P_CDFILIAL  ) AND
            (VO.CDCIA     = P_CDCIA     ) AND
            (VO.NRVOO     = P_NRVOO);
      IF (P_QTTOTPAXAT + P_QTPAXSBY) IS NULL THEN
      BEGIN
         SELECT MAX(QTPAXEQUI),MAX(QTPAXSBYEQUI)
         INTO P_QTTOTPAXAT, P_QTPAXSBY
         FROM CONFIGEQUI CE, VOO VO
         WHERE (CE.CDFILIAL = P_CDFILIAL) AND
               (CE.CDCIA    = P_CDCIA   ) AND
               (CE.CDCLASSE = P_CDCLASSE) AND
               (CE.CDEQUIP  = VO.CDEQUIP) AND
               (VO.CDFILIAL = P_CDFILIAL) AND
               (VO.CDCIA    = P_CDCIA   ) AND
               (VO.NRVOO    = P_NRVOO   );
      END;
      END IF;*/
   END;
   END IF;
   P_QTTOTPAXAT_QTPAXSBY := P_QTTOTPAXAT + P_QTPAXSBY;
END;
/


