/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PADSERVICO                                               */
/* Tabela : PADSERVICO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PADSERVICO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PADSERVICO
GO

CREATE TRIGGER DTULTATU_PADSERVICO
ON PADSERVICO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PADSERVICO', null, 'CDPADSERV='+ CDPADSERV+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PADSERVICO
      SET DTULTATUPADS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PADSERVICO.CDPADSERV,0)   = ISNULL(INSERTED.CDPADSERV,0)) AND
            (ISNULL(PADSERVICO.SGPADSERV,0)   = ISNULL(INSERTED.SGPADSERV,0)) AND
            (ISNULL(PADSERVICO.DSPADSERV,0)   = ISNULL(INSERTED.DSPADSERV,0)) AND
            (ISNULL(PADSERVICO.CDNVPADSERV,0) = ISNULL(INSERTED.CDNVPADSERV,0));
   END;
END;
GO

